package sk.tuke.bkpi.extensions;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Map;

public class ModificationPolicyManager {
	
	private Map <String, ArrayList <ClassModificationPolicy>> modificationPolicy = new Hashtable <String, ArrayList <ClassModificationPolicy>>();
	
	public boolean CheckModificationPolicyDefinitionSyntax (String modificationPolicy)
	{
		String x = new String("(((\\s)*#MODIFICATION_POLICY_DEFINITION((\\s)+#LANGUAGES(\\s)*=(\\s)*\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\](((\\s)+#LOCAL_POLICY(\\s)+#MACHINES(\\s)*=(\\s*)\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\](((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)))(\\s)+#END_LOCAL_POLICY)*(\\s)+#GLOBAL_POLICY(((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)))(\\s)+#END_GLOBAL_POLICY((\\s)+#LOCAL_POLICY(\\s)+#MACHINES(\\s)*=(\\s*)\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\](((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)))(\\s)+#END_LOCAL_POLICY)*|((\\s)+#LOCAL_POLICY(\\s)+#MACHINES(\\s)*=(\\s*)\\[(\\s)*(\\w)+(\\s)*(,(\\s)*(\\w)+(\\s)*)*\\](((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)))(\\s)+#END_LOCAL_POLICY)+)(\\s)*)*)|(\\s)*)");
		x = x.replace("(((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION))|((\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(ALLOW_ADDITION|FORBID_ADDITION|FORBID_DIRECT_ADDITION)))(\\s)+", "(\\s)+(#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+|#CONSTRUCTOR_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#METHOD_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+#ATRIBUTE_POLICY(\\s)*=(\\s)*(FREE|ADDITIVE|REDUCTIVE|CONSTANT)(\\s)+)");
		
		if (modificationPolicy.matches(x))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public String TrimModificationPolicy (String modificationPolicy)
	{
		String trimmedModificationPolicy = new String();
		for (int count = 0; count < modificationPolicy.length(); count++)
		{
		
			if (modificationPolicy.substring(count, count + 1).matches("[\\w,#\\[\\]=]"))
			{
				trimmedModificationPolicy = trimmedModificationPolicy + modificationPolicy.substring(count, count + 1);
			}
		}
		return trimmedModificationPolicy;
	}
	
	public boolean CheckLanguageDuplicationError(String modificationPolicy)
	{
		if (CheckModificationPolicyDefinitionSyntax(modificationPolicy))
		{
			ArrayList <String> Languages = new ArrayList <String>();
			
			String trimmedModificationPolicy = TrimModificationPolicy(modificationPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				if (policyOfLanguageGroup.startsWith("="))
				{
					String languageList = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("[") + 1, policyOfLanguageGroup.indexOf("]"));
					String[] languagesOfLanguageGroup = languageList.split(",");
					for (String languageOfLanguageGroup: languagesOfLanguageGroup)
					{
						if (!Languages.contains(languageOfLanguageGroup))
						{
							Languages.add(languageOfLanguageGroup);
						}
						else
						{
							return false;
						}
					}
				}
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public boolean CheckMachineDuplicationError(String modificationPolicy)
	{
		if ( CheckModificationPolicyDefinitionSyntax(modificationPolicy))
		{
			String trimmedModificationPolicy = TrimModificationPolicy(modificationPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				if ((policyOfLanguageGroup.startsWith("=")) && (policyOfLanguageGroup.contains("#LOCAL_POLICY")))
				{
					ArrayList <String> AllMachinesOfLanguageGroup = new ArrayList <String>();
					while (policyOfLanguageGroup.contains("#LOCAL_POLICY"))
					{
						String LocalPolicyOfTheMachine = policyOfLanguageGroup.substring((policyOfLanguageGroup.indexOf("#LOCAL_POLICY") + 13), policyOfLanguageGroup.indexOf("#END_LOCAL_POLICY"));
						String machinesList = LocalPolicyOfTheMachine.substring((LocalPolicyOfTheMachine.indexOf("[") + 1), LocalPolicyOfTheMachine.indexOf("]"));
						String[] machines = machinesList.split(",");
						for (String machine: machines)
						{
							if (AllMachinesOfLanguageGroup.contains(machine))
							{
								return false;
							}
							else
							{
								AllMachinesOfLanguageGroup.add(machine);
							}
						}
						policyOfLanguageGroup = policyOfLanguageGroup.substring(0, policyOfLanguageGroup.indexOf("#LOCAL_POLICY")) + policyOfLanguageGroup.substring ((policyOfLanguageGroup.indexOf("#END_LOCAL_POLICY") + 17), policyOfLanguageGroup.length());
					}	
				}
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public boolean CheckMachineDuplicationError(File modificationPolicy)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(modificationPolicy));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		      
		      return CheckMachineDuplicationError (contents.toString());
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
		    return false;
	}
	
	public void ReadModificationPolicy (String modificationPolicy)
	{
		if ((CheckModificationPolicyDefinitionSyntax (modificationPolicy)) && (CheckLanguageDuplicationError(modificationPolicy)) && (CheckMachineDuplicationError(modificationPolicy)))
		{
			
			String trimmedModificationPolicy = TrimModificationPolicy(modificationPolicy);
			String[] policyOfLanguageGroups = trimmedModificationPolicy.split("#LANGUAGES"); 
			
			for (String policyOfLanguageGroup: policyOfLanguageGroups)
			{
				if (policyOfLanguageGroup.startsWith("="))
				{
					
					String languageList = policyOfLanguageGroup.substring(policyOfLanguageGroup.indexOf("[") + 1, policyOfLanguageGroup.indexOf("]"));
					String[] languagesOfLanguageGroup = languageList.split(",");
					
					for (String languageOfLanguageGroup: languagesOfLanguageGroup)
					{
						this.modificationPolicy.put(languageOfLanguageGroup, new ArrayList<ClassModificationPolicy>());
					}
					
					ClassElementModificationPolicy GMP = ClassElementModificationPolicy.free; 
					ClassElementModificationPolicy GAP = ClassElementModificationPolicy.free;
					ClassElementModificationPolicy GCP = ClassElementModificationPolicy.free;
					
					if (policyOfLanguageGroup.contains("#GLOBAL_POLICY"))
					{
						String globalPolicyOfLanguageGroup = policyOfLanguageGroup.substring((policyOfLanguageGroup.indexOf("#GLOBAL_POLICY") + 14), policyOfLanguageGroup.indexOf("#END_GLOBAL_POLICY"));
						
						if (globalPolicyOfLanguageGroup.contains("#METHOD_POLICY"))
						{
							String globalMethodPolicyOfLanguageGroup = globalPolicyOfLanguageGroup.substring((globalPolicyOfLanguageGroup.indexOf("#METHOD_POLICY") + 15));
							
							if (globalMethodPolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								GMP = ClassElementModificationPolicy.free; 	
							}
							
							if (globalMethodPolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								GMP = ClassElementModificationPolicy.additive; 	
							}							

							if (globalMethodPolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								GMP = ClassElementModificationPolicy.reductive; 	
							}

							if (globalMethodPolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								GMP = ClassElementModificationPolicy.constant; 	
							}							

						}
						
						if (globalPolicyOfLanguageGroup.contains("#ATRIBUTE_POLICY"))
						{
							String globalAtributePolicyOfLanguageGroup = globalPolicyOfLanguageGroup.substring((globalPolicyOfLanguageGroup.indexOf("#ATRIBUTE_POLICY") + 17));
						
							if (globalAtributePolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								GAP = ClassElementModificationPolicy.free; 	
							}
							
							if (globalAtributePolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								GAP = ClassElementModificationPolicy.additive; 	
							}							
							
							if (globalAtributePolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								GAP = ClassElementModificationPolicy.reductive; 	
							}	
							
							if (globalAtributePolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								GAP = ClassElementModificationPolicy.constant; 	
							}							
							
						}
						
						if (globalPolicyOfLanguageGroup.contains("#CONSTRUCTOR_POLICY"))
						{
							String globalConstructorPolicyOfLanguageGroup = globalPolicyOfLanguageGroup.substring((globalPolicyOfLanguageGroup.indexOf("#CONSTRUCTOR_POLICY") + 20));
						
							if (globalConstructorPolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								GCP = ClassElementModificationPolicy.free; 	
							}
							
							if (globalConstructorPolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								GCP = ClassElementModificationPolicy.additive; 	
							}							
							
							if (globalConstructorPolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								GCP = ClassElementModificationPolicy.reductive; 	
							}	
							
							if (globalConstructorPolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								GCP = ClassElementModificationPolicy.constant; 	
							}							
							
						}						
						
						
					}
					
					for (String languageOfLanguageGroup: languagesOfLanguageGroup)
					{
						this.modificationPolicy.get(languageOfLanguageGroup).add(new ClassModificationPolicy(GMP, GAP, GCP));
						//System.out.println (GMP.toString() + GAP.toString() + GCP.toString());
					}
					
					while (policyOfLanguageGroup.contains("#LOCAL_POLICY"))
					{
						String LocalPolicyOfTheMachine = policyOfLanguageGroup.substring((policyOfLanguageGroup.indexOf("#LOCAL_POLICY") + 13), policyOfLanguageGroup.indexOf("#END_LOCAL_POLICY"));
						
						String machinesList = LocalPolicyOfTheMachine.substring((LocalPolicyOfTheMachine.indexOf("[") + 1), LocalPolicyOfTheMachine.indexOf("]"));
						String[] machines = machinesList.split(",");
						
						ClassElementModificationPolicy LMP = ClassElementModificationPolicy.free; 
						ClassElementModificationPolicy LAP = ClassElementModificationPolicy.free;
						ClassElementModificationPolicy LCP = ClassElementModificationPolicy.free;
						
						if (LocalPolicyOfTheMachine.contains("#METHOD_POLICY"))
						{
							String LocalMethodPolicyOfLanguageGroup = LocalPolicyOfTheMachine.substring((LocalPolicyOfTheMachine.indexOf("#METHOD_POLICY") + 15));
							
							if (LocalMethodPolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								LMP = ClassElementModificationPolicy.free; 	
							}
							
							if (LocalMethodPolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								LMP = ClassElementModificationPolicy.additive; 	
							}							
							
							if (LocalMethodPolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								LMP = ClassElementModificationPolicy.reductive; 	
							}	

							if (LocalMethodPolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								LMP = ClassElementModificationPolicy.constant; 	
							}	
							
						}
						
						if (LocalPolicyOfTheMachine.contains("#ATRIBUTE_POLICY"))
						{
							String localAtributePolicyOfLanguageGroup = LocalPolicyOfTheMachine.substring((LocalPolicyOfTheMachine.indexOf("#ATRIBUTE_POLICY") + 17));
						
							if (localAtributePolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								LAP = ClassElementModificationPolicy.free; 	
							}
							
							if (localAtributePolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								LAP = ClassElementModificationPolicy.additive; 	
							}							
							
							if (localAtributePolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								LAP = ClassElementModificationPolicy.reductive; 	
							}		
							
							if (localAtributePolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								LAP = ClassElementModificationPolicy.constant; 	
							}								
							
						}
						
						if (LocalPolicyOfTheMachine.contains("#CONSTRUCTOR_POLICY"))
						{
							String localConstructorPolicyOfLanguageGroup = LocalPolicyOfTheMachine.substring((LocalPolicyOfTheMachine.indexOf("#CONSTRUCTOR_POLICY") + 20));
						
							if (localConstructorPolicyOfLanguageGroup.substring(0, 1).equals("F"))
							{
								LCP = ClassElementModificationPolicy.free; 	
							}
							
							if (localConstructorPolicyOfLanguageGroup.substring(0, 1).equals("A"))
							{
								LCP = ClassElementModificationPolicy.additive; 	
							}							
							
							if (localConstructorPolicyOfLanguageGroup.substring(0, 1).equals("R"))
							{
								LCP = ClassElementModificationPolicy.reductive; 	
							}		
							
							if (localConstructorPolicyOfLanguageGroup.substring(0, 1).equals("C"))
							{
								LCP = ClassElementModificationPolicy.constant; 	
							}								
							
						}						
						
						for (String languageOfLanguageGroup: languagesOfLanguageGroup)
						{
							for (String machine: machines)
							{	
								this.modificationPolicy.get(languageOfLanguageGroup).add(new ClassModificationPolicy(machine, LMP, LAP, LCP));
								//System.out.println(machine + LMP.toString() + LAP.toString() + LCP.toString());
							}		
						}		
						policyOfLanguageGroup = policyOfLanguageGroup.substring(0, policyOfLanguageGroup.indexOf("#LOCAL_POLICY")) + policyOfLanguageGroup.substring ((policyOfLanguageGroup.indexOf("#END_LOCAL_POLICY") + 17), policyOfLanguageGroup.length());
					}
				}
			}	
		}
	}
	
	public void ReadModificationPolicy (File modificationPolicy)
	{
		StringBuffer contents = new StringBuffer();
		BufferedReader reader = null; 
		try {
		      reader = new BufferedReader(new FileReader(modificationPolicy));
              String text = null;
		      while ((text = reader.readLine()) != null) {
		               contents.append(text)
	                   .append(System.getProperty(
		                        "line.separator"));
		           }
		      
		       ReadModificationPolicy (contents.toString());
		    } catch (FileNotFoundException e) {
		           e.printStackTrace();
		    } catch (IOException e) {
		            e.printStackTrace();
		    } finally {
		                try {
		                if (reader != null) {
		                    reader.close();
		                }
		              } catch (IOException e) {
		                e.printStackTrace();
		                                      }
		    }
	}
	
	
	public String WriteModificationPolicy()
	{
		String modificationPolicy = new String ("#MODIFICATION_POLICY_DEFINITION\n");
		
		for (String language: this.modificationPolicy.keySet())
		{
			
			modificationPolicy = modificationPolicy + "   #LANGUAGES = [" + language + "]\n";
			
			for (ClassModificationPolicy classModificationPolicy: this.modificationPolicy.get(language))
			{
				
				if (classModificationPolicy.getClassName().equals("#GLOBAL"))
				{
					modificationPolicy = modificationPolicy + "      #GLOBAL_POLICY\n";
					
					modificationPolicy = modificationPolicy + "         #METHOD_POLICY = ";
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					
	
					modificationPolicy = modificationPolicy + "\n";	
					
					modificationPolicy = modificationPolicy + "         #ATRIBUTE_POLICY = ";
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}			
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					

					modificationPolicy = modificationPolicy + "\n";	
					
					modificationPolicy = modificationPolicy + "         #CONSTRUCTOR_POLICY = ";
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}			
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					

					modificationPolicy = modificationPolicy + "\n";						
										
					modificationPolicy = modificationPolicy + "      #END_GLOBAL_POLICY\n";
				}
				else
				{
					modificationPolicy = modificationPolicy + "      #LOCAL_POLICY  #MACHINES = [" + classModificationPolicy.getClassName() +"]\n";
					
					modificationPolicy = modificationPolicy + "         #METHOD_POLICY = ";
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}
					
					if (classModificationPolicy.getMethodPolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					
	
					modificationPolicy = modificationPolicy + "\n";	
					
					modificationPolicy = modificationPolicy + "         #ATRIBUTE_POLICY = ";
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}			
					
					if (classModificationPolicy.getAtributePolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					

					modificationPolicy = modificationPolicy + "\n";	
					
					modificationPolicy = modificationPolicy + "         #CONSTRUCTOR_POLICY = ";
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.free)
					{
						modificationPolicy = modificationPolicy + "FREE";		
					}
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.additive)
					{
						modificationPolicy = modificationPolicy + "ADDITIVE";		
					}	
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.reductive)
					{
						modificationPolicy = modificationPolicy + "REDUCTIVE";		
					}			
					
					if (classModificationPolicy.getConstructorPolicy() == ClassElementModificationPolicy.constant)
					{
						modificationPolicy = modificationPolicy + "CONSTANT";		
					}					

					modificationPolicy = modificationPolicy + "\n";							
					
					modificationPolicy = modificationPolicy + "      #END_LOCAL_POLICY\n";
				}	
			}			
		}
		return modificationPolicy;
	}
	
	public ArrayList <ClassModificationPolicy> getLanguageModificationPolicy(String language)
	{
		if (this.modificationPolicy.containsKey(language))
		{
			return this.modificationPolicy.get(language);
		}
		else
		{
			return new ArrayList <ClassModificationPolicy>();
		}
	}
	
}
