package sk.tuke.bkpi.generator;

import sk.tuke.bkpi.generator.JavaGenerator.CodeGenerator;
import sk.tuke.bkpi.model.b0data.ArrayFieldVariable;
import sk.tuke.bkpi.model.b0data.B0Variable;
import sk.tuke.bkpi.model.term.ArrayExpression;
import sk.tuke.bkpi.model.types.Type;

/**
 * Provides interface to B-Method array expressions translation
 * to the target language.
 * @author Marcel Dancak
 */
public interface ArrayGenerator {
	
	//String arrayDeclaration(DataField arrayVariable);
	String arrayType(Type arrayType);
	
	String setElement();
	
	String getElement(ArrayFieldVariable expr);
	
	String arrayInitialization(B0Variable arrayVariable, ArrayExpression initialization, CodeGenerator generator);//remove
	String arrayExpression(ArrayExpression array, CodeGenerator codeGenerator);
}
