package sk.tuke.bkpi.model.b0data;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.types.Type;

public class B0VariableReference extends B0Variable {

	private DataField variable;
	
	public B0VariableReference(DataField variable) {
		this.variable = variable;
	}
	
	public DataField variable() {
		return variable;
	}
	
	@Override
	public boolean isTyped() {
		return variable.isTyped();
	}
	
	@Override
	public Type type() {
		return variable.type();
	}
	
	@Override
	public void typeData(Type type) {
		variable.typeData(type);
	}
	
	@Override
	public String toString() {
		return ""+variable;
	}
}
