package sk.tuke.bkpi.model.clause;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import sk.tuke.bkpi.model.data.DataValue;
public class Values {

	private Map<String, DataValue> values = new Hashtable<String, DataValue>();
	
	public Values(List<Valuation> valuations) {
		for (Valuation valuation : valuations) {
			values.put(valuation.constantName, valuation.value);
		}
	}
	
	public Map<String, DataValue> values() {
		return values;
	}
	
	public static class Valuation {
		private String constantName;
		private DataValue value;
		
		public Valuation(String constantName, DataValue value) {
			this.constantName = constantName;
			this.value = value;
		}
	}
	
	@Override
	public String toString() {
		return values.toString();
	}
}
