package sk.tuke.bkpi.model.condition;

public class BinaryCondition extends Condition {

	public enum Operator {
		CONJUNCTION,
		DISJUNCTION
	}
	
	private Operator  operator;
	private Condition left;
	private Condition right;
	
	public BinaryCondition(Operator operator, Condition left, Condition right) {
		this.operator = operator;
		this.left  = left;
		this.right = right;
	}
	
	public Condition getLeft() {
		return left;
	}
	
	public Condition getRight() {
		return right;
	}
	
	public Operator getOperator() {
		return operator;
	}
}
