package sk.tuke.bkpi.model.condition;

import sk.tuke.bkpi.model.data.B0DataValue;

public class ComparisonCondition extends Condition {

	public enum Operator {
		EQUAL,
		NOT_EQUAL,
		LESS,
		LESS_OR_EQUAL,
		GREATER,
		GREATER_OR_EQUAL
	}
	
	private Operator operator;
	private B0DataValue left,right;
	
	public ComparisonCondition(Operator operator, B0DataValue left, B0DataValue right) {
		this.operator = operator;
		this.left  = left;
		this.right = right;
	}
	
	public Operator operator() {
		return operator;
	}
	
	public B0DataValue left() {
		return left;
	}
	
	public B0DataValue right() {
		return right;
	}
}
