package sk.tuke.bkpi.model.expression;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.types.Z;

public class IntervalExpression extends BinaryExpression {

	public IntervalExpression(Expression from, Expression to) {
		super(from, to);
		typeCheckLeft(Z);
		typeCheckRight(Z);
		//type = PowerSet(Z);
		type = PowerSet(new Z(this));
	}
	
	@Override
	public String toString() {
		return left+".."+right;
	}
}
