package sk.tuke.bkpi.model.expression;

import java.util.Map;

public abstract class OneArgumentFunction extends Expression {

	protected final Expression argument;
	
	public OneArgumentFunction(Expression argument) {
		this.argument = argument;
	}
	
	public Expression argument() {
		return argument;
	}
	
	public Expression instance(Map<Object, Object> substitution) {
		Expression leftInstance = substitution.containsKey(argument)? (Expression) substitution.get(argument) : argument.instance(substitution);
		if (leftInstance == argument)
			return this;
		// TODO !!!
		return this;
	}
}
