package sk.tuke.bkpi.model.expression;

import java.util.ArrayList;
import java.util.List;

import sk.tuke.bkpi.model.types.Record;

public class RecordExpression extends Expression {

	private List<RecordField> fields;
	
	public RecordExpression(List<RecordField> fields) {
		this.fields = fields;
		List<Record.Field> fieldsTypes = new ArrayList<Record.Field>(fields.size()); 
		for (RecordField field : fields) {
			fieldsTypes.add(new Record.Field(field.label, field.value.type()));
		}
		type = new Record(fieldsTypes);
	}
}
