package sk.tuke.bkpi.model.expression.arithmetical;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.expression.OneArgumentFunction;
import static sk.tuke.bkpi.model.types.BasicType.*;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class CardinalExpression extends OneArgumentFunction {
	
	/*
	 * 
	 * argument
	 */
	public CardinalExpression(Expression argument) {
		super(argument);
		argument.typeCheck(PowerSet(GENERIC));
		type = Z;
	}
}
