package sk.tuke.bkpi.model.expression.arithmetical;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import sk.tuke.bkpi.model.expression.Expression;

public class Negation extends Expression {

	private Expression expression;
	
	public Negation(Expression expression) {
		expression.typeCheck(Z);
		type = Z;
		
		this.expression = expression;
	}
	
	public Expression expression() {
		return expression;
	}
	
	@Override
	public String toString() {
		return "-"+expression;
	}
}
