package sk.tuke.bkpi.model.expression.sequence;

import sk.tuke.bkpi.model.expression.Expression;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import static sk.tuke.bkpi.model.types.BasicType.Z;

public class EmptySequence extends Expression {

	/*
	 * no fixed type. type is matching P(Zx?)
	 */
	public static final EmptySequence EMPTY_SEQUENCE = new EmptySequence();
	
	private EmptySequence() {
		type = PowerSet(CartesianProduct(Z, GENERIC));
	}
	
	@Override
	public String toString() {
		return "<>";
	}
}
