package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.expression.BinaryExpression;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeBuilder;
import sk.tuke.bkpi.model.types.TypeCheckException;
import sk.tuke.bkpi.model.types.TypeResolver;

public class InsertInFront extends BinaryExpression {

	protected static TypeResolver T = new TypeResolver();
	private static Type SEQUENCE_TYPE = PowerSet(CartesianProduct(Z, T));
	
	public InsertInFront(Expression sequence, Expression element) {
		super(sequence, element);
		System.out.println("seq type: "+sequence.type());
		System.out.println("elem type: "+element.type());
		
		/*
		if (!left.type().isSubtype(SEQUENCE_TYPE))
			throw new TypeCheckException("NOT a Sequence type: "+left.type());
		else
			System.out.println("INSERT TO SEQUENCE: "+left.type()+" FULFIL "+SEQUENCE_TYPE);
		*/
		typeCheckLeft(SEQUENCE_TYPE);
		SEQUENCE_TYPE.resolveType(sequence.type());
		System.out.println("INSERT resolved type: "+T.resolvedType());
		System.out.println("sequence type: "+sequence.type());
		SEQUENCE_TYPE.resolveType(sequence.type());
		System.out.println("later resolved type: "+T.resolvedType());
		
		//if (!element.type().isSubtype(T.resolvedType()))
		if (!element.type().isCompatibile(T.resolvedType()))
			throw new TypeCheckException("Expected element of type: "+T+", but has: "+element);
		//Type elementType = T.resolvedType().inference(element.type());
		//what type has: 2 -> <>
		type = PowerSet(CartesianProduct(Z, T.resolvedType().inference(element.type())));
		//type = sequence.getType();
	}
}
