package sk.tuke.bkpi.model.predicate;

import java.util.Map;

public class NegationPredicate extends Predicate {
	
	private Predicate predicate;
	
	public NegationPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	@Override
	public Predicate instance(Map<Object, Object> substitution) {
		Predicate instance = predicate.instance(substitution);
		return instance == predicate ? this : new NegationPredicate(instance);
	}
}
