package sk.tuke.bkpi.model.predicate;

import java.util.List;
import java.util.Map;

import sk.tuke.bkpi.model.data.LocalVariable;

public class UniversalPredicate extends Predicate {
	
	private List<LocalVariable> variables;
	private BinaryPredicate implication;

	public UniversalPredicate(List<LocalVariable> variables, BinaryPredicate implication) {
		this.variables = variables;
		this.implication = implication;
	}

	@Override
	public Predicate instance(Map<Object, Object> substitution) {
		Predicate instance = implication.instance(substitution);
		return instance == implication? this : new UniversalPredicate(variables, implication);
	}
}
