package sk.tuke.bkpi.model.substitution;

import sk.tuke.bkpi.model.predicate.Predicate;

public class Branch {
	private Predicate condition;
	private Substitution substitution;
	
	public Branch(Predicate condition, Substitution substitution) {
		this.condition = condition;
		this.substitution = substitution;
	}

	public Predicate condition() {
		return condition;
	}
	
	public Substitution substitution() {
		return substitution;
	}
}
