package sk.tuke.bkpi.model.substitution;

import java.util.List;

public class ChoiceSubstitution extends Substitution {

	private List<Substitution> choices;
	
	public ChoiceSubstitution(List<Substitution> choices) {
		if (choices.size() < 2)
			throw new IllegalArgumentException("List must contains at least 2 substitutions");
		this.choices = choices;
	}
	
	public List<Substitution> choices() {
		return choices;
	}
}
