package sk.tuke.bkpi.model.term;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;
import sk.tuke.bkpi.model.data.B0DataValue;

public class IntegerSetB0 extends B0DataValue {
	
	public static final IntegerSetB0 NAT = new IntegerSetB0(Set.NAT);
	public static final IntegerSetB0 NAT1 = new IntegerSetB0(Set.NAT1);
	public static final IntegerSetB0 INT = new IntegerSetB0(Set.INT);
	
	enum Set {
		NAT,
		NAT1,
		INT
	}
	
	private Set set;
	
	public IntegerSetB0(Set set) {
		this.set = set;
		type = PowerSet(Z);
	}

}

