package sk.tuke.bkpi.model.term;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.BasicType;


public class IntegerTerm extends B0DataValue {

	private Integer value;
	
	public IntegerTerm(Integer value) {
		this.value = value;
		type = BasicType.Z;
	}
	
	public Integer value() {
		return value;
	}
	
	@Override
	public String toString() {
		return value.toString();
	}
}
