package sk.tuke.bkpi.model.term;

import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.BasicType;

public class NegativeTerm extends B0DataValue {

	private B0DataValue expression;
	
	public NegativeTerm(B0DataValue expression) {
		this.expression = expression;
		expression.typeCheck(BasicType.Z);
		type = BasicType.Z;
	}
	
	public B0DataValue expression() {
		return expression;
	}
	
	@Override
	public String toString() {
		return "(-"+expression+")";
	}
}
