package sk.tuke.bkpi.model.types;

import sk.tuke.bkpi.model.clause.Set;

public class SetType extends BasicType {

	private Set set;
	
	public SetType(Set set) {
		super(set.name());// or set.name() ?
		this.set = set;
	}
	
	public Set set() {
		int var = 5;
		{
			//int var = 10;
		}
		
		return set;
	}
	
	@Override
	public boolean isCompatibile(Type t) {
		return this.isEqual(t) || t instanceof GenericType;
	}
	
	@Override
	public boolean isEqual(Type t) {
		if (t instanceof SetType) {
			return ((SetType) t).set.name().equals(set.name());
		}
		return false;
	}
	
	/*
	@Override
	public final boolean isCompatibile(Type t) {
		if (t instanceof SetType) {
			return t == this;
			//return ((SetType) t).set == this.set;
			//return ((SetType)t).set.name().equals(set.name());
		}
		return t instanceof GenericType;
	}
	*/
	@Override
	public boolean isSubtype(Type t) {
		return t instanceof GenericType || isEqual(t);
	}
	
	@Override
	public Type replace(Type oldType, Type newType) {
		System.out.println(this+" replace test "+oldType+ " by "+ newType+" :"+isEqual(oldType));
		if (isEqual(oldType)) {
			System.out.println("and da result is: "+super.replace(oldType, newType));
		}
		return super.replace(oldType, newType);
	}
	/*
	@Override
	public String toString() {
		return set.name();
	}
	*/
}