package sk.tuke.bkpi.model.types;

public abstract class Type {

	public abstract boolean isEqual(Type t);
	public abstract boolean isCompatibile(Type t);
	//public boolean isCompatibile(Type t) { return isSubtype(t);}
	
	public abstract boolean isSubtype(Type t);
	
	public void resolveType(Type t) {
		if (t instanceof TypeResolver)
			((TypeResolver)t).resolvedType = this;
	}
	
	public abstract boolean containsGenricType();
	public abstract boolean contains(Type type);
	
	public abstract Type inference(Type t);
	
	public Type replace(Type oldType, Type newType) {
		return this.isEqual(oldType)? newType : this;
	}
	
}
