package sk.tuke.bkpi.model.types;

public class TypeBuilder {
	
	public static final Type GENERIC = new GenericType();
	
	public static Type CartesianProduct(Type first, Type second) {
		if (first instanceof PowerSet && second instanceof PowerSet)
			return new PowerSet(new CartesianProduct(((PowerSet)first).baseType(), ((PowerSet)second).baseType()));
		return new CartesianProduct(first, second);
	}
	public static Type CartesianProductOfSets(Type first, Type second) {
		if (first instanceof PowerSet && second instanceof PowerSet)
			return new PowerSet(CartesianProductOfSets(((PowerSet)first).baseType(), ((PowerSet)second).baseType()));
		//else throw new TypeCheckException("must be P(T)");
		return new CartesianProduct(first, second);
	}
	
	public static PowerSet PowerSet(Type baseType) {
		return new PowerSet(baseType);
	}
	
}
