package sk.tuke.bkpi.extensions;

public class ClassModificationPolicy {
	
	private String ClassName;
	
	private ClassElementModificationPolicy method_policy;
	private ClassElementModificationPolicy atribute_policy;
	private ClassElementModificationPolicy constructor_policy;
	
	public ClassModificationPolicy()
	{
		this.method_policy = ClassElementModificationPolicy.free;
		this.atribute_policy = ClassElementModificationPolicy.free;
		this.constructor_policy = ClassElementModificationPolicy.free;
		this.ClassName = "#GLOBAL";
	}
	
	public ClassModificationPolicy (ClassElementModificationPolicy method_policy, ClassElementModificationPolicy atribute_policy, ClassElementModificationPolicy constructor_policy)
	{
		this.method_policy = method_policy;
		this.atribute_policy = atribute_policy;
		this.constructor_policy = constructor_policy;
		this.ClassName = "#GLOBAL";
	}
	
	public ClassModificationPolicy (String ClassName, ClassElementModificationPolicy method_policy, ClassElementModificationPolicy atribute_policy, ClassElementModificationPolicy constructor_policy)
	{
	this.ClassName = ClassName;
	this.method_policy = method_policy;
	this.atribute_policy = atribute_policy;
	this.constructor_policy = constructor_policy;
	}
	
	public String getClassName()
	{
		return this.ClassName;
	}

	public ClassElementModificationPolicy getMethodPolicy()
	{
		return this.method_policy;
	}
	
	public ClassElementModificationPolicy getAtributePolicy()
	{
		return this.atribute_policy;
	}
	
	public ClassElementModificationPolicy getConstructorPolicy()
	{
		return this.constructor_policy;
	}
	
}
