package sk.tuke.bkpi.generator;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Map;

public class RecordItemsNameManager {
	
	private Map <String, Hashtable <String, String>> records = new Hashtable <String, Hashtable <String, String>>();
	
	private Collection<String> excluded_words = Collections.emptyList();
	
	public void setExcluded_words(String ... excluded_words) {
		this.excluded_words = Arrays.asList(excluded_words);
	}
	
	public void setExcluded_words(Collection<String> excluded_words) {
		this.excluded_words = excluded_words;
	}
	
	public String record_data (String record_class_name, String record_item_name)
	{
		if (this.records.containsKey(record_class_name))
		{
			if (this.records.get(record_class_name).containsKey(record_item_name))
			{
				return this.records.get(record_class_name).get(record_item_name);
			}
			else
			{
				String result = new String(record_item_name);
				while ((this.excluded_words.contains(result)) || (this.records.get(record_class_name).containsValue(result)))
				{
					result = result + "_data";
				}
				this.records.get(record_class_name).put(record_item_name, result);
				return result;	
			}	
		}
		else
		{
			this.records.put(record_class_name, new Hashtable<String, String>());
			String result = new String(record_item_name);
			while (this.excluded_words.contains(result))
			{
				result = result + "_data";
			}
			this.records.get(record_class_name).put(record_item_name, result);
			return result;				
		}
			
	}

}
