package sk.tuke.bkpi.generator.support;

import java.util.ArrayList;

import sk.tuke.bkpi.extensions.ClassAccessPolicy;

public class AccessPolicyResolver {

	ArrayList <ClassAccessPolicy> languageAccessPolicy;
	
	public AccessPolicyResolver (ArrayList <ClassAccessPolicy> languageAccessPolicy)
	{
		this.languageAccessPolicy = languageAccessPolicy;
	}
	
	public boolean applyAllForbyddenExceptAllowedByCode(String machineName)
	{
		
		ClassAccessPolicy globalPolicy = new ClassAccessPolicy();
		for (ClassAccessPolicy classAccessPolicy: this.languageAccessPolicy)
		{
			if (!classAccessPolicy.getClassName().equals("#ALL"))
			{
				if (classAccessPolicy.getClassName().equals(machineName))
				{
					Integer accessPolicyImplementation = classAccessPolicy.getClassAccessPolicy();
					if (accessPolicyImplementation > 99)
					{
						accessPolicyImplementation = accessPolicyImplementation - 100;
					}
					
					if (accessPolicyImplementation > 9)
					{
						accessPolicyImplementation = accessPolicyImplementation - 10;
					}
					
					if (accessPolicyImplementation > 0)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				globalPolicy = classAccessPolicy;
			}	
		}
		
		Integer accessPolicyImplementation = globalPolicy.getClassAccessPolicy();
		if (accessPolicyImplementation > 99)
		{
			accessPolicyImplementation = accessPolicyImplementation - 100;
		}
		
		if (accessPolicyImplementation > 9)
		{
			accessPolicyImplementation = accessPolicyImplementation - 10;
		}
		
		if (accessPolicyImplementation > 0)
		{
			return true;
		}
		else
		{
			return false;
		}			
		
	}
	
	public boolean applyAllForbyddenExceptAllowedByComment(String machineName)
	{
		
		ClassAccessPolicy globalPolicy = new ClassAccessPolicy();
		for (ClassAccessPolicy classAccessPolicy: this.languageAccessPolicy)
		{
			if (!classAccessPolicy.getClassName().equals("#ALL"))
			{
				if (classAccessPolicy.getClassName().equals(machineName))
				{
					Integer accessPolicyImplementation = classAccessPolicy.getClassAccessPolicy();
					if (accessPolicyImplementation > 99)
					{
						accessPolicyImplementation = accessPolicyImplementation - 100;
					}
					
					if (accessPolicyImplementation > 9)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				globalPolicy = classAccessPolicy;
			}	
		}
		
		Integer accessPolicyImplementation = globalPolicy.getClassAccessPolicy();
		if (accessPolicyImplementation > 99)
		{
			accessPolicyImplementation = accessPolicyImplementation - 100;
		}
		
		if (accessPolicyImplementation > 9)
		{
			return true;
		}
		else
		{
			return false;
		}	
		
	}
	
	public boolean applyAllForbyddenExceptAllowedByReport(String machineName)
	{
		
		ClassAccessPolicy globalPolicy = new ClassAccessPolicy();
		for (ClassAccessPolicy classAccessPolicy: this.languageAccessPolicy)
		{
			if (!classAccessPolicy.getClassName().equals("#ALL"))
			{
				if (classAccessPolicy.getClassName().equals(machineName))
				{
					Integer accessPolicyImplementation = classAccessPolicy.getClassAccessPolicy();
					
					if (accessPolicyImplementation > 99)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				globalPolicy = classAccessPolicy;
			}	
		}
		
		Integer accessPolicyImplementation = globalPolicy.getClassAccessPolicy();
		
		if (accessPolicyImplementation > 99)
		{
			return true;
		}
		else
		{
			return false;
		}		
	}	
	
	public boolean applyAllForbiddenExceptAllowed(String machineName)
	{
		if ((applyAllForbyddenExceptAllowedByReport(machineName)) || (applyAllForbyddenExceptAllowedByComment(machineName)) || (applyAllForbyddenExceptAllowedByCode(machineName)))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
}
