package sk.tuke.bkpi.model.clause;

import sk.tuke.bkpi.model.data.DataField;
import sk.tuke.bkpi.model.types.PowerSet;
import sk.tuke.bkpi.model.types.SetType;
import sk.tuke.bkpi.model.types.Type;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public abstract class Set extends DataField {

	protected String name;
	
	public Set(String name) {
		super(name);
		type = PowerSet(new SetType(this));
	}
	
	public PowerSet type() {
		return (PowerSet) type;
	}
}
