package sk.tuke.bkpi.model.component;

import java.util.List;

import sk.tuke.bkpi.model.clause.Set;
import sk.tuke.bkpi.model.data.AbstractConstant;
import sk.tuke.bkpi.model.data.AbstractVariable;
import sk.tuke.bkpi.model.data.ConcreteConstant;
import sk.tuke.bkpi.model.data.ConcreteVariable;

public interface AbstractComponent {
	List<AbstractVariable> abstractVariables();
	List<AbstractConstant> abstractConstants();
	List<ConcreteConstant> concreteConstants();
	List<ConcreteVariable> concreteVariables();
	List<Set> sets();
	List<Set> includedSets();
}
