package sk.tuke.bkpi.model.component;

import java.util.Collections;
import java.util.List;

import sk.tuke.bkpi.model.data.DataField;

public class Header {
	
	private String name;
	private List<DataField> parameters;

	public Header(String name, List<DataField> parameters) {
		this.name = name;
		this.parameters = parameters != null? parameters : Collections.<DataField>emptyList();
	}
	
	public String name() {
		return name;
	}

	public List<DataField> parameters() {
		return parameters;
	}

	@Override
	public String toString() {
		return "Header[name:"+name+" params: "+parameters+"]";
	}
}
