package sk.tuke.bkpi.model.expression;

import sk.tuke.bkpi.model.types.BasicType;

public class IntegerLiteral extends Expression {

	private Integer value;
	
	public IntegerLiteral(Integer value) {
		this.value = value;
		type = BasicType.Z;
	}
	
	public Integer value() {
		return value;
	}
	
	@Override
	public String toString() {
		return value.toString();
	}
}
