package sk.tuke.bkpi.model.expression.arithmetical;

import java.util.List;

import sk.tuke.bkpi.model.data.LocalVariable;
import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.predicate.Predicate;
import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;

public class GeneralizedExpression extends Expression {

	private List<LocalVariable> variables;
	private Predicate predicate;
	private Expression expression;
	
	public GeneralizedExpression(List<LocalVariable> variables, Predicate predicate, Expression expression) {
		System.out.println(expression + " type: "+expression.type());
		//typeCheck(PowerSet(GENERIC), expression);
		expression.typeCheck(Z);
		
		this.variables  = variables;
		this.predicate  = predicate;
		this.expression = expression;
		type = Z;
	}
}
