package sk.tuke.bkpi.model.expression.sequence;

import static sk.tuke.bkpi.model.types.BasicType.Z;
import static sk.tuke.bkpi.model.types.TypeBuilder.CartesianProduct;
import static sk.tuke.bkpi.model.types.TypeBuilder.PowerSet;

import java.util.List;

import sk.tuke.bkpi.model.expression.Expression;

public class SequenceExtension extends Expression {

	private List<Expression> expressions;
	
	public SequenceExtension(List<Expression> expressions) {
		this.expressions = expressions;
		
		// TODO:
		type = PowerSet(CartesianProduct(Z, expressions.get(0).type()));
	}
}
