package sk.tuke.bkpi.model.expression.sequence;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import sk.tuke.bkpi.model.types.TypeResolver;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import static sk.tuke.bkpi.model.types.BasicType.*;

public abstract class SequenceFunction extends Expression {

	protected TypeResolver U = new TypeResolver();
	private Type SEQUENCE_TYPE = PowerSet(CartesianProduct(Z, U));
	
	protected Expression argument;
	
	public SequenceFunction(Expression argument) {
		argument.typeCheckAndResolve(SEQUENCE_TYPE);
		this.argument = argument;
	}
}
