package sk.tuke.bkpi.model.expression.set;

import sk.tuke.bkpi.model.expression.Expression;
import sk.tuke.bkpi.model.types.Type;
import static sk.tuke.bkpi.model.types.TypeBuilder.*;
import static sk.tuke.bkpi.model.types.BasicType.*;

public class ExpressionSet extends Expression {

	//public static final ExpressionSet EMPTY_SET = new ExpressionSet(GENERIC_TYPE);
	private static final Type POWERSET_OF_INTEGER = PowerSet(Z);
	
	public static final ExpressionSet INTEGER  = new ExpressionSet(POWERSET_OF_INTEGER);
	public static final ExpressionSet NATURAL  = new ExpressionSet(POWERSET_OF_INTEGER);
	public static final ExpressionSet NATURAL1 = new ExpressionSet(POWERSET_OF_INTEGER);
	public static final ExpressionSet INT      = new ExpressionSet(POWERSET_OF_INTEGER);
	public static final ExpressionSet NAT      = new ExpressionSet(POWERSET_OF_INTEGER);
	public static final ExpressionSet NAT1     = new ExpressionSet(POWERSET_OF_INTEGER);
	
	public static final ExpressionSet STRING_SET  = new ExpressionSet(PowerSet(STRING));
	
	public static final ExpressionSet BOOLEAN_SET = new ExpressionSet(PowerSet(BOOL));
	
	public ExpressionSet(Type type) {
		this.type = type;
	}
	/*
	public static class EmptySet extends ExpressionSet {
		private EmptySet() {
			//type = genericType 
		}
	}
	*/
}
