package sk.tuke.bkpi.model.instruction;

import java.util.List;

import sk.tuke.bkpi.model.data.LocalVariable;

public class LocalVariableInstruction extends Instruction {

	private List<LocalVariable> localVariables;
	private Instruction  substitution;
	
	public LocalVariableInstruction(List<LocalVariable> localVariables, Instruction  substitution) {
		this.localVariables = localVariables;
		this.substitution   = substitution; 
	}
	
	public List<LocalVariable> localVariables() {
		return localVariables;
	}
	
	public Instruction substitution() {
		return substitution;
	}
	
	@Override
	public String toString() {
		return localVariables+" substitution: "+substitution;
	}
}
