package sk.tuke.bkpi.model.substitution;

import sk.tuke.bkpi.model.predicate.Predicate;

public class AssertionSubstitution extends Substitution {
	
	private Predicate assertion;
	private Substitution substitution;
	
	public AssertionSubstitution(Predicate assertion, Substitution substitution) {
		this.assertion = assertion;
		this.substitution = substitution;
	}

	public Predicate getAssertion() {
		return assertion;
	}
	
	public Substitution getSubstitution() {
		return substitution;
	}

}
