package sk.tuke.bkpi.model.substitution;

import sk.tuke.bkpi.model.predicate.Predicate;

public class PreconditionSubstitution extends Substitution {

	private Predicate precondition;
	private Substitution substitution;
	
	public PreconditionSubstitution(Predicate precondition, Substitution substitution) {
		this.precondition = precondition;
		this.substitution = substitution;
	}

	public Predicate getPrecondition() {
		return precondition;
	}
	
	public Substitution getSubstitution() {
		return substitution;
	}
}
