package sk.tuke.bkpi.model.term;

import sk.tuke.bkpi.model.condition.Condition;
import sk.tuke.bkpi.model.data.B0DataValue;
import sk.tuke.bkpi.model.types.BasicType;

public class BoolConversionValue extends B0DataValue {

	private Condition predicate;
	
	public BoolConversionValue(Condition predicate) {
		this.predicate = predicate;
		type = BasicType.BOOL;
	}
	
	public Condition predicate() {
		return predicate;
	}
}
