package sk.tuke.bkpi.model.types;

public class GenericType extends Type {

	public static GenericType GENERIC = new GenericType();
	
	GenericType() {
	}
	
	@Override
	public boolean isEqual(Type t) {
		return this == t;
	}
	/*
	@Override
	public boolean isGeneric() {
		return true;
	}
	*/
	@Override
	public boolean isCompatibile(Type t) {
		return true;
	}
	
	@Override
	public boolean isSubtype(Type t) {
		return t instanceof GenericType;//t.isGeneric();
	}
	
	@Override
	public boolean containsGenricType() {
		return true;
	}
	
	public boolean contains(Type type) {
		return isEqual(type);
	}
	
	@Override
	public Type inference(Type t) {
		return t;
	}
	
	@Override
	public String toString() {
		return "?";
	}
}
