package sk.tuke.bkpi.model.types;


public final class TypeResolver extends GenericType {

	Type resolvedType = GENERIC;
	
	public Type resolvedType() {
		return resolvedType;
	}
	
	@Override
	public boolean isEqual(Type t) {
		return this == t;
	}
	
	@Override
	public final boolean isCompatibile(Type t) {
		resolvedType = t;
		return true;
	}
	
	@Override
	public boolean isSubtype(Type t) {
		resolvedType = t;
		return t instanceof GenericType;
	}
	
	// ?? resolveType ??
	@Override
	public void resolveType(Type t) {
		resolvedType = t;
	}
	
	@Override
	public String toString() {
		return resolvedType == null || resolvedType == this? "?" : resolvedType.toString();
	}
}
