package sk.tuke.bkpi.parser;

public class Couple<T1, T2> {

	private T1 first;
	private T2 second;
	
	public Couple(T1 first, T2 second) {
		this.first = first;
		this.second = second;
	}
	
	public T1 first() {
		return first;
	}
	
	public T2 second() {
		return second;
	}
	
	@Override
	@SuppressWarnings("unchecked")
	public boolean equals(Object obj) {
		return (obj instanceof Couple && ((Couple)obj).first == first && ((Couple)obj).second == second);
	}
}
