package sk.tuke.bkpi.parser;

import java.io.File;

public class ProjectParseException extends RuntimeException {

	private File file;
	
	public ProjectParseException(String msg, File file) {
		super(msg);
		this.file = file;
	}
	
	public ProjectParseException(Throwable throwable, File file) {
		super(throwable);
		this.file = file;
	}
	
	public ProjectParseException(String msg, Throwable throwable, File file) {
		super(msg, throwable);
		this.file = file;
	}
	
	public File getSource() {
		return file;
	}
}
